zoukankan      html  css  js  c++  java
  • hdu-5521 Meeting(最短路)

    题目链接:

    Meeting

    Time Limit: 12000/6000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others)
    Total Submission(s): 2024    Accepted Submission(s): 628


    Problem Description
    Bessie and her friend Elsie decide to have a meeting. However, after Farmer John decorated his
    fences they were separated into different blocks. John's farm are divided into n blocks labelled from 1 to n.
    Bessie lives in the first block while Elsie lives in the n-th one. They have a map of the farm
    which shows that it takes they ti minutes to travel from a block in Ei to another block
    in Ei where Ei (1im) is a set of blocks. They want to know how soon they can meet each other
    and which block should be chosen to have the meeting.
     
    Input
    The first line contains an integer T (1T6), the number of test cases. Then T test cases
    follow.

    The first line of input contains n and m2n105. The following m lines describe the sets Ei (1im). Each line will contain two integers ti(1ti109) and Si (Si>0) firstly. Then Si integer follows which are the labels of blocks in Ei. It is guaranteed that mi=1Si106.
     
    Output
    For each test case, if they cannot have the meeting, then output "Evil John" (without quotes) in one line.

    Otherwise, output two lines. The first line contains an integer, the time it takes for they to meet.
    The second line contains the numbers of blocks where they meet. If there are multiple
    optional blocks, output all of them in ascending order.
     
    Sample Input
    2 5 4 1 3 1 2 3 2 2 3 4 10 2 1 5 3 3 3 4 5 3 1 1 2 1 2
     
    Sample Output
    Case #1: 3
    3 4
    Case #2: Evil John
     
    题意:
     
    现在给出一个图,其中分成点分成一个集合一个集合的,每一集合中的点互相之间的距离都是相同的,也给出来了;现在要求两个人分别从1和n出发,问最短多长时间才能遇到,且给出这些可能的相遇点;
     
    思路:
     
    这显然是一个最短路的问题,找出那些两个人都能到达且时间尽量小的点,主要问题是如何高效的求出最短路,
    由于一个集合里面的点任意两点之间的距离相同,那么可以新建一个点,然后这个集合里面的点与它相连这个距离的边,最后求的最短距离取一半就好了;
     
    AC代码:
     
    #include <iostream>
    #include <cstdio>
    #include <cstring>
    #include <algorithm>
    #include <cmath>
    #include <bits/stdc++.h>
    #include <stack>
    #include <map>
      
    using namespace std;
      
    #define For(i,j,n) for(int i=j;i<=n;i++)
    #define mst(ss,b) memset(ss,b,sizeof(ss));
    #define lson o<<1
    #define rson o<<1|1
    typedef  long long LL;
      
    template<class T> void read(T&num) {
        char CH; bool F=false;
        for(CH=getchar();CH<'0'||CH>'9';F= CH=='-',CH=getchar());
        for(num=0;CH>='0'&&CH<='9';num=num*10+CH-'0',CH=getchar());
        F && (num=-num);
    }
    int stk[70], tp;
    template<class T> inline void print(T p) {
        if(!p) { puts("0"); return; }
        while(p) stk[++ tp] = p%10, p/=10;
        while(tp) putchar(stk[tp--] + '0');
        putchar('
    ');
    }
      
    const LL mod=1e9+7;
    const double PI=acos(-1.0);
    const LL inf=1e18;
    const int N=1e6+10;
    const int maxn=2e6+5;
    const double eps=1e-12;
    
    int n,m,cnt,s,e,vis[maxn],c[maxn],head[maxn];
    LL dis[2][maxn];
    struct Edge
    {
        int to,next,val;
    }edge[maxn];
    queue<int>qu;
    inline void add_edge(int from,int to,int va)
    {
        edge[cnt].to=to;
        edge[cnt].next=head[from];
        edge[cnt].val=va;
        head[from]=cnt++;
    }
    
    void solve(int s,int e,int f)
    {
        while(!qu.empty())qu.pop();
        mst(vis,0);
        for(int i=0;i<maxn;i++)dis[f][i]=inf;
        dis[f][s]=0;
        qu.push(s);
        vis[s]=1;
        while(!qu.empty())
        {
            int fr=qu.front();qu.pop();
            for(int i=head[fr];i!=-1;i=edge[i].next)
            {
                int x=edge[i].to;
                if(dis[f][x]>dis[f][fr]+edge[i].val)
                {
                    dis[f][x]=dis[f][fr]+edge[i].val;
                    if(!vis[x])qu.push(x),vis[x]=1;
                }
            }
            vis[fr]=0;
        }
    }
    int main()
    {
        int t,Case=0;
        read(t);
        while(t--)
        {
            printf("Case #%d: ",++Case);
            mst(head,-1);
            cnt=0;
            read(n);read(m);
            int x,h,t;
            for(int i=1;i<=m;i++)
            {
                read(t);read(h);
                for(int j=1;j<=h;j++)
                {
                    read(x);
                    add_edge(x,n+i,t);
                    add_edge(n+i,x,t);
                }
            }
            solve(1,n,0);
            solve(n,1,1);
            LL ans=inf;
            for(int i=1;i<=n;i++)ans=min(ans,max(dis[0][i],dis[1][i]));
            if(ans==inf)printf("Evil John
    ");
            else 
            {
                printf("%lld
    ",ans/2);
                int num=0;
                for(int i=1;i<=n;i++)if(max(dis[0][i],dis[1][i])==ans)c[++num]=i;
                for(int i=1;i<num;i++)printf("%d ",c[i]);
                printf("%d
    ",c[num]);
            }
        }
        return 0;
    }
    

      

     
     
  • 相关阅读:
    乱七八糟
    堆-heap
    转linux文件的读写
    @转EXT2->EXT3->EXT4
    (转)僵死进程与孤儿进程
    java
    poj-1062-昂贵的聘礼
    java 之 wait, notify, park, unpark , synchronized, Condition
    事物(笔记)
    BPX-tree
  • 原文地址:https://www.cnblogs.com/zhangchengc919/p/5928373.html
Copyright © 2011-2022 走看看